## source-code.7z

=== Makefile ===
## This is a self-documented Makefile. For usage information, run `make help`:
##
## For more information, refer to https://suva.sh/posts/well-documented-makefiles/

WIRE_TAGS = "oss"

-include local/Makefile
include .bingo/Variables.mk

GO = go
GO_VERSION = 1.24.3
GO_LINT_FILES ?= $(shell ./scripts/go-workspace/golangci-lint-includes.sh)
GO_TEST_FILES ?= $(shell ./scripts/go-workspace/test-includes.sh)
SH_FILES ?= $(shell find ./scripts -name *.sh)
GO_RACE  := $(shell [ -n "$(GO_RACE)" -o -e ".go-race-enabled-locally" ] && echo 1 )
GO_RACE_FLAG := $(if $(GO_RACE),-race)
GO_BUILD_FLAGS += $(if $(GO_BUILD_DEV),-dev)
GO_BUILD_FLAGS += $(if $(GO_BUILD_TAGS),-build-tags=$(GO_BUILD_TAGS))
GO_BUILD_FLAGS += $(GO_RACE_FLAG)
GO_TEST_OUTPUT := $(shell [ -n "$(GO_TEST_OUTPUT)" ] && echo '-json | tee $(GO_TEST_OUTPUT) | tparse -all')
GIT_BASE = remotes/origin/main

# GNU xargs has flag -r, and BSD xargs (e.g. MacOS) has that behaviour by default
XARGSR = $(shell xargs --version 2>&1 | grep -q GNU && echo xargs -r || echo xargs)

targets := $(shell echo '$(sources)' | tr "," " ")

GO_INTEGRATION_TESTS := $(shell find ./pkg -type f -name '*_test.go' -exec grep -l '^func TestIntegration' '{}' '+' | grep -o '\(.*\)/' | sort -u)

.PHONY: all
all: deps build

##@ Dependencies

.PHONY: deps-go
deps-go: ## Install backend dependencies.
	$(GO) run $(GO_RACE_FLAG) build.go setup

.PHONY: deps-js
deps-js: node_modules ## Install frontend dependencies.

.PHONY: deps
deps: deps-js ## Install all dependencies.

.PHONY: node_modules
node_modules: package.json yarn.lock ## Install node modules.
	@echo "install frontend dependencies"
	YARN_ENABLE_PROGRESS_BARS=false yarn install --immutable

##@ Swagger
SPEC_TARGET = public/api-spec.json
ENTERPRISE_SPEC_TARGET = public/api-enterprise-spec.json
MERGED_SPEC_TARGET = public/api-merged.json
NGALERT_SPEC_TARGET = pkg/services/ngalert/api/tooling/api.json

$(NGALERT_SPEC_TARGET):
	+$(MAKE) -C pkg/services/ngalert/api/tooling api.json

$(MERGED_SPEC_TARGET): swagger-oss-gen swagger-enterprise-gen $(NGALERT_SPEC_TARGET) $(SWAGGER) ## Merge generated and ngalert API specs
	# known conflicts DsPermissionType, AddApiKeyCommand, Json, Duration (identical models referenced by both specs)
	$(SWAGGER) mixin -q $(SPEC_TARGET) $(ENTERPRISE_SPEC_TARGET) $(NGALERT_SPEC_TARGET) --ignore-conflicts -o $(MERGED_SPEC_TARGET)

.PHONY: swagger-oss-gen
swagger-oss-gen: $(SWAGGER) ## Generate API Swagger specification
	@echo "re-generating swagger for OSS"
	rm -f $(SPEC_TARGET)
	SWAGGER_GENERATE_EXTENSION=false $(SWAGGER) generate spec -q -m -w pkg/server -o $(SPEC_TARGET) \
	-x "github.com/grafana/grafana/pkg/services/ngalert/api/tooling/definitions" \
	-x "github.com/grpc-ecosystem/grpc-gateway/v2/protoc-gen-openapiv2/options" \
	-x "github.com/prometheus/alertmanager" \
	-i pkg/api/swagger_tags.json \
	--exclude-tag=alpha \
	--exclude-tag=enterprise

# this file only exists if enterprise is enabled
.PHONY: swagger-enterprise-gen
ENTERPRISE_EXT_FILE = pkg/extensions/ext.go
ifeq ("$(wildcard $(ENTERPRISE_EXT_FILE))","") ## if enterprise is not enabled
swagger-enterprise-gen:
	@echo "skipping re-generating swagger for enterprise: not enabled"
else
swagger-enterprise-gen: $(SWAGGER) ## Generate API Swagger specification
	@echo "re-generating swagger for enterprise"
	rm -f $(ENTERPRISE_SPEC_TARGET)
	SWAGGER_GENERATE_EXTENSION=false $(SWAGGER) generate spec -q -m -w pkg/server -o $(ENTERPRISE_SPEC_TARGET) \
	-x "github.com/grafana/grafana/pkg/services/ngalert/api/tooling/definitions" \
	-x "github.com/grpc-ecosystem/grpc-gateway/v2/protoc-gen-openapiv2/options" \
	-x "github.com/prometheus/alertmanager" \
	-i pkg/api/swagger_tags.json \
	--exclude-tag=alpha \
	--include-tag=enterprise
endif

.PHONY: swagger-gen
swagger-gen: gen-go $(MERGED_SPEC_TARGET) swagger-validate

.PHONY: swagger-validate
swagger-validate: $(MERGED_SPEC_TARGET) $(SWAGGER) ## Validate API spec
	$(SWAGGER) validate --skip-warnings $(<)

.PHONY: swagger-clean
swagger-clean:
	rm -f $(SPEC_TARGET) $(MERGED_SPEC_TARGET) $(OAPI_SPEC_TARGET)

.PHONY: cleanup-old-git-hooks
cleanup-old-git-hooks:
	./scripts/cleanup-husky.sh

.PHONY: lefthook-install
lefthook-install: cleanup-old-git-hooks $(LEFTHOOK) # install lefthook for pre-commit hooks
	$(LEFTHOOK) install -f

.PHONY: lefthook-uninstall
lefthook-uninstall: $(LEFTHOOK)
	$(LEFTHOOK) uninstall

##@ OpenAPI 3
OAPI_SPEC_TARGET = public/openapi3.json

.PHONY: openapi3-gen
openapi3-gen: swagger-gen ## Generates OpenApi 3 specs from the Swagger 2 already generated
	$(GO) run $(GO_RACE_FLAG) scripts/openapi3/openapi3conv.go $(MERGED_SPEC_TARGET) $(OAPI_SPEC_TARGET)

##@ Internationalisation
.PHONY: i18n-extract-enterprise
ENTERPRISE_FE_EXT_FILE = public/app/extensions/index.ts
ifeq ("$(wildcard $(ENTERPRISE_FE_EXT_FILE))","") ## if enterprise is not enabled
i18n-extract-enterprise:
	@echo "Skipping i18n extract for Enterprise: not enabled"
else
i18n-extract-enterprise:
	@echo "Extracting i18n strings for Enterprise"
	yarn run i18next --config public/locales/i18next-parser-enterprise.config.cjs
	node ./public/locales/pseudo.mjs --mode enterprise
endif

.PHONY: i18n-extract
i18n-extract: i18n-extract-enterprise
	@echo "Extracting i18n strings for OSS"
	yarn run i18next --config public/locales/i18next-parser.config.cjs
	node ./public/locales/pseudo.mjs --mode oss

##@ Building
.PHONY: gen-cue
gen-cue: ## Do all CUE/Thema code generation
	@echo "generate code from .cue files"
	go generate ./kinds/gen.go
	go generate ./public/app/plugins/gen.go

.PHONY: gen-cuev2
gen-cuev2: ## Do all CUE code generation
	@echo "generate code from .cue files (v2)"
	@$(MAKE) -C ./kindsv2 all

.PHONY: gen-feature-toggles
gen-feature-toggles:
## First go test run fails because it will re-generate the feature toggles.
## Second go test run will compare the generated files and pass.
	@echo "generate feature toggles"
	go test -v ./pkg/services/featuremgmt/... > /dev/null 2>&1; \
	if [ $$? -eq 0 ]; then \
		echo "feature toggles already up-to-date"; \
	else \
		go test -v ./pkg/services/featuremgmt/...; \
	fi

.PHONY: gen-go
gen-go:
	@echo "generate go files"
	$(GO) run $(GO_RACE_FLAG) ./pkg/build/wire/cmd/wire/main.go gen -tags $(WIRE_TAGS) ./pkg/server

.PHONY: fix-cue
fix-cue: $(CUE)
	@echo "formatting cue files"
	$(CUE) fix kinds/**/*.cue
	$(CUE) fix public/app/plugins/**/**/*.cue

.PHONY: gen-jsonnet
gen-jsonnet:
	go generate ./devenv/jsonnet

.PHONY: update-workspace
update-workspace: gen-go
	@echo "updating workspace"
	bash scripts/go-workspace/update-workspace.sh

.PHONY: build-go
build-go: gen-go update-workspace ## Build all Go binaries.
	@echo "build go files with updated workspace"
	$(GO) run build.go $(GO_BUILD_FLAGS) build

build-go-fast: gen-go ## Build all Go binaries.
	@echo "build go files"
	$(GO) run build.go $(GO_BUILD_FLAGS) build

.PHONY: build-backend
build-backend: ## Build Grafana backend.
	@echo "build backend"
	$(GO) run build.go $(GO_BUILD_FLAGS) build-backend

.PHONY: build-server
build-server: ## Build Grafana server.
	@echo "build server"
	$(GO) run build.go $(GO_BUILD_FLAGS) build-server

.PHONY: build-cli
build-cli: ## Build Grafana CLI application.
	@echo "build grafana-cli"
	$(GO) run build.go $(GO_BUILD_FLAGS) build-cli

.PHONY: build-js
build-js: ## Build frontend assets.
	@echo "build frontend"
	yarn run build

PLUGIN_ID ?=

.PHONY: build-plugin-go
build-plugin-go: ## Build decoupled plugins
	@echo "build plugin $(PLUGIN_ID)"
	@cd pkg/tsdb; \
	if [ -z "$(PLUGIN_ID)" ]; then \
		echo "PLUGIN_ID is not set"; \
		exit 1; \
	fi; \
	mage -v buildplugin $(PLUGIN_ID)

.PHONY: build
build: build-go build-js ## Build backend and frontend.

.PHONY: run
run: $(BRA) ## Build and run web server on filesystem changes. See /.bra.toml for configuration.
	$(BRA) run

.PHONY: run-go
run-go: ## Build and run web server immediately.
	$(GO) run -race $(if $(GO_BUILD_TAGS),-build-tags=$(GO_BUILD_TAGS)) \
		./pkg/cmd/grafana -- server -profile -profile-addr=127.0.0.1 -profile-port=6000 -packaging=dev cfg:app_mode=development

.PHONY: run-frontend
run-frontend: deps-js ## Fetch js dependencies and watch frontend for rebuild
	yarn start

##@ Testing

.PHONY: test-go
test-go: test-go-unit test-go-integration

.PHONY: test-go-unit
test-go-unit: ## Run unit tests for backend with flags.
	@echo "test backend unit tests"
	$(GO) test $(GO_RACE_FLAG) -short -covermode=atomic -coverprofile=unit.cov -timeout=30m $(GO_TEST_FILES) $(GO_TEST_OUTPUT)

.PHONY: test-go-unit-pretty
test-go-unit-pretty: check-tparse
	@if [ -z "$(FILES)" ]; then \
		echo "Notice: FILES variable is not set. Try \"make test-go-unit-pretty FILES=./pkg/services/mysvc\""; \
		exit 1; \
	fi
	$(GO) test $(GO_RACE_FLAG) -timeout=10s $(FILES) -json | tparse -all

.PHONY: test-go-integration
test-go-integration: ## Run integration tests for backend with flags.
	@echo "test backend integration tests"
	$(GO) test $(GO_RACE_FLAG) -count=1 -run "^TestIntegration" -covermode=atomic -coverprofile=integration.cov -timeout=5m $(GO_INTEGRATION_TESTS) $(GO_TEST_OUTPUT)

.PHONY: test-go-integration-alertmanager
test-go-integration-alertmanager: ## Run integration tests for the remote alertmanager (config taken from the mimir_backend block).
	@echo "test remote alertmanager integration tests"
	$(GO) clean -testcache
	AM_URL=http://localhost:8080 AM_TENANT_ID=test \
	$(GO) test $(GO_RACE_FLAG) -count=1 -run "^TestIntegrationRemoteAlertmanager" -covermode=atomic -timeout=5m ./pkg/services/ngalert/...

.PHONY: test-go-integration-grafana-alertmanager
test-go-integration-grafana-alertmanager: ## Run integration tests for the grafana alertmanager
	@echo "test grafana alertmanager integration tests"
	@export GRAFANA_VERSION=11.5.0-81938; \
	$(GO) run tools/setup_grafana_alertmanager_integration_test_images.go; \
	$(GO) clean -testcache; \
	$(GO) test $(GO_RACE_FLAG) -count=1 -run "^TestAlertmanagerIntegration" -covermode=atomic -timeout=10m ./pkg/tests/alertmanager/...

.PHONY: test-go-integration-postgres
test-go-integration-postgres: devenv-postgres ## Run integration tests for postgres backend with flags.
	@echo "test backend integration postgres tests"
	$(GO) clean -testcache
	GRAFANA_TEST_DB=postgres \
	$(GO) test $(GO_RACE_FLAG) -p=1 -count=1 -run "^TestIntegration" -covermode=atomic -timeout=10m $(GO_INTEGRATION_TESTS)

.PHONY: test-go-integration-mysql
test-go-integration-mysql: devenv-mysql ## Run integration tests for mysql backend with flags.
	@echo "test backend integration mysql tests"
	GRAFANA_TEST_DB=mysql \
	$(GO) test $(GO_RACE_FLAG) -p=1 -count=1 -run "^TestIntegration" -covermode=atomic -timeout=10m $(GO_INTEGRATION_TESTS)

.PHONY: test-go-integration-redis
test-go-integration-redis: ## Run integration tests for redis cache.
	@echo "test backend integration redis tests"
	$(GO) clean -testcache
	REDIS_URL=localhost:6379 $(GO) test $(GO_RACE_FLAG) -run IntegrationRedis -covermode=atomic -timeout=2m $(GO_INTEGRATION_TESTS)

.PHONY: test-go-integration-memcached
test-go-integration-memcached: ## Run integration tests for memcached cache.
	@echo "test backend integration memcached tests"
	$(GO) clean -testcache
	MEMCACHED_HOSTS=localhost:11211 $(GO) test $(GO_RACE_FLAG) -run IntegrationMemcached -covermode=atomic -timeout=2m $(GO_INTEGRATION_TESTS)

.PHONY: test-js
test-js: ## Run tests for frontend.
	@echo "test frontend"
	yarn test

.PHONY: test
test: test-go test-js ## Run all tests.

##@ Linting
.PHONY: golangci-lint
golangci-lint: $(GOLANGCI_LINT)
	@echo "lint via golangci-lint"
	$(GOLANGCI_LINT) run \
		--config .golangci.yml \
		$(GO_LINT_FILES)

.PHONY: lint-go
lint-go: golangci-lint ## Run all code checks for backend. You can use GO_LINT_FILES to specify exact files to check

.PHONY: lint-go-diff
lint-go-diff: $(GOLANGCI_LINT)
	git diff --name-only $(GIT_BASE) | \
		grep '\.go$$' | \
		$(XARGSR) dirname | \
		sort -u | \
		sed 's,^,./,' | \
		$(XARGSR) $(GOLANGCI_LINT) run --config .golangci.toml

=== kindsv2/Makefile ===
include ../.bingo/Variables.mk

.PHONY: all
all: dashboards

.PHONY: dashboards
dashboards: $(COG) ## Dashboards – Typescript
	@$(COG) generate --config ./dashboard-ts.yaml

=== apps/advisor/Makefile ===
.PHONY: generate
generate:
	@grafana-app-sdk generate -g ./pkg/apis --grouping=group --postprocess --defencoding=none

=== tests/libsubid/04_nss/Makefile ===
all: test_nss libsubid_zzz.so

test_nss: test_nss.c ../../../lib/nss.c
	gcc -c -I../../../lib/ -I../../.. -o test_nss.o test_nss.c
	gcc -o test_nss test_nss.o ../../../libmisc/.libs/libmisc.a ../../../lib/.libs/libshadow.a -ldl

libsubid_zzz.so: libsubid_zzz.c
	gcc -c -I../../../lib/ -I../../.. -I../../../libmisc -I../../../libsubid libsubid_zzz.c
	gcc -L../../../libsubid -shared -o libsubid_zzz.so libsubid_zzz.o ../../../lib/.libs/libshadow.a -ldl

clean:
	rm -f *.o *.so test_nss

=== debian/changelog ===
dpkg (1.21.23) UNRELEASED; urgency=medium

  *

 -- Guillem Jover <guillem@debian.org>  Sat, 21 Oct 2023 02:31:45 +0200

dpkg (1.21.22) unstable; urgency=medium

  [ Guillem Jover ]
  * Code internals:
    - libdpkg: Handle missing Version when formatting source:Upstream-Version.
      Reported by John Scott <jscott@posteo.net>.
  * Localization:
    - Add Portuguese scripts translations.
      Thanks to Américo Monteiro <a_monteiro@gmx.com>. Closes: #1032562

 -- Guillem Jover <guillem@debian.org>  Thu, 11 May 2023 04:04:01 +0200

dpkg (1.21.21) unstable; urgency=medium

  * Architecture support:
    - Restore "arch: Add support for loong64 CPU". Closes: #1028654
  * Localization:
    - Update Dutch header boilerplate with an actual copyright line.
    - Update French scripts translation.
      Thanks to Sébastien Poher <sebastien@volted.net>.

 -- Guillem Jover <guillem@debian.org>  Sat, 25 Feb 2023 04:39:29 +0100

dpkg (1.21.20) unstable; urgency=medium

  [ Guillem Jover ]
  * Documentation:
    - man: Remove duplicate word in dpkg-buildflags(1).
      Thanks to Peter Krefting <peter@softwolves.pp.se>.
  * Packaging:
    - Fix versioned Build-Depends on debhelper. Closes: #1030288
    - Update lintian overrides.
  * Test suite:
    - Update suppressions for cppcheck 2.10.
    - Skip auto-generated policykit policy file.
  * Localization:
    - Add Dutch scripts translation. Closes: #1030712
      Thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be>.
    - Unfuzzy translations due to typo fix.
    - Update Czech translations. Closes: #1029706, #1030267
      Thanks to Miroslav Kure <kurem@upcase.inf.upol.cz>.
    - Update Dutch translations. Closes: #1030710, #1030711
      Thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be>.
    - Update French man page translation. Closes: #1030618
      Thanks to Jean-Pierre Giraud <jenapierregiraud75@free.fr>.
    - Update French programs translations.
      Thanks to Sébastien Poher <sebastien@volted.net>.
    - Update Hungarian programs translation.
      Thanks to Nagy Elemér Károly <nagy.elemer.karoly@gmail.com>.
    - Update Korean dselect translation.
      Thanks to Sangdo Jun <sebuls@gmail.com>.
    - Update Occitan programs translation.
      Thanks to Quentin PAGÈS <quentinantonin@free.fr>.
    - Update Portuguese programs translation.
      Thanks to Miguel Figueiredo <elmig@debianpt.org>.
    - Update Romanian programs translation.
      Thanks to Remus-Gabriel Chelu <remusgabriel.chelu@disroot.org>.
    - Update Russian translations. Closes: #1030162, #1030378
      Thanks to Yuri Kozlov <yuray@komyakino.ru>.
    - Update Simplified Chinese translations.
      Thanks to Boyuan Yang <byang@debian.org>.
    - Update Spanish dselect translation.
      Thanks to jonatan porras <jonatanpc8@gmail.com>.
    - Update Swedish translations.
      Thanks to Peter Krefting <peter@softwolves.pp.se>.
    - Update Thai programs translation.
      Thanks to Theppitak Karoonboonyanan <thep@debian.org>.
    - Update Traditional Chinese dselect translation.
      Thanks to Cheng-Chia Tseng <pswo10680@gmail.com>.
    - Workaround po4a formatting issue in French translation.

 -- Guillem Jover <guillem@debian.org>  Tue, 07 Feb 2023 12:19:12 +0100

dpkg (1.21.19) unstable; urgency=medium

  [ Guillem Jover ]
  * Architecture support:
    - Revert "arch: Add support for loong64 CPU". See #1028654.
  * Perl modules:
    - Dpkg::OpenPGP::Backend::GnuPG: Set secure signing preferred algorithms.
      Closes: #1028961
    - Dpkg::OpenPGP::Backend::GnuPG: Touch trustedkeys.gpg on temporary gpg
      home.
    - Dpkg::OpenPGP::Backend::GnuPG: Fallback to use «gpg dearmor» if
      present. Reported by Sven Joachim <svenjoac@gmx.de> (on IRC).
    - Dpkg::Vendor::Ubuntu: Fix lto feature to honor DEB_BUILD_OPTIONS.
  * Test suite:
    - Set the permissions explicitly for the copied ChangeLog.old file.
    - Add unit tests for lto build flags handling in Ubuntu.
      Thanks to Shengjing Zhu <shengjing.zhu@canonical.com>.
      See https://bugs.launchpad.net/bugs/2002582.
  * Localization:
    - Update Catalan translation.
    - Update Portuguese man pages translation.
      Thanks to Américo Monteiro <a_monteiro@gmx.com>. Closes: #1028981

  [ Sven Joachim ]
  * Localization:
    - Update German programs translation.

  [ Helge Kreutzmann ]
  * Localization:
    - Update German man pages translation.

 -- Guillem Jover <guillem@debian.org>  Tue, 24 Jan 2023 23:39:50 +0100

dpkg (1.21.18) unstable; urgency=medium

  [ Guillem Jover ]
  * Perl modules:
    - Dpkg::BuildFlags: Fix strip method to always work with duplicates.
      Closes: #1028044
  * Documentation:
    - man: Add a note to dpkg-fsys-usrunmess(8) about Debian support.
      Closes: #1008486
  * Code internals:
    - libdpkg: Move compression level max bound check from dpkg-deb.
    - libdpkg: Switch dpkg_lzma_strerror() to use struct io_lzma.
    - libdpkg: Split compression filter operation tracking from its status.
    - libdpkg: Generalize compression stream action handling.
    - libdpkg: Abstract compression stream status tracking.
    - libdpkg: Add zstd support for .deb archives. Closes: #892664
  * Build system:
    - Update .mailmap mappings.
  * Packaging:
    - Update copyright years.
  * Test suite:
    - Add dpkg-deb build and extract tests.

 -- Guillem Jover <guillem@debian.org>  Tue, 10 Jan 2023 18:46:37 +0100

dpkg (1.21.17) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-genbuildinfo: Do not fail if the cross-compiler cannot compile.
    Closes: #1027966
  * Code internals:
    - dpkg-buildinfo: Fix indentation.
  * Packaging:
    - Stop shipping the «git log» changelog in exchange for no trimming.
      Closes: #1027716

 -- Guillem Jover <guillem@debian.org>  Thu, 05 Jan 2023 12:34:05 +0100

dpkg (1.21.16) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-deb: Fix buffer overflow on long directory names with old deb formats.


=== debian/control ===
Source: xz-utils
Section: utils
Priority: optional
Maintainer: Jonathan Nieder <jrnieder@gmail.com>
Uploaders: Mohammed Adnène Trojette <adn+deb@diwi.org>
Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.2),
 autoconf (>= 2.64~), automake, libtool (>= 2.2),
 gettext, autopoint | gettext (<< 0.18-1), autopoint | cvs, po4a
Build-Depends-Indep: doxygen
Build-Conflicts: automake1.4
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/debian/xz-utils
Vcs-Git: https://salsa.debian.org/debian/xz-utils
Homepage: https://tukaani.org/xz/
Rules-Requires-Root: no

Package: liblzma5
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Breaks: liblzma2 (<< 5.1.1alpha+20110809-3~)
Multi-Arch: same
Description: XZ-format compression library
 XZ is the successor to the Lempel-Ziv/Markov-chain Algorithm
 compression format, which provides memory-hungry but powerful
 compression (often better than bzip2) and fast, easy decompression.
 .
 The native format of liblzma is XZ; it also supports raw (headerless)
 streams and the older LZMA format used by lzma. (For 7-Zip's related
 format, use the p7zip package instead.)

Package: xz-utils
Priority: standard
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: foreign
Conflicts: lzma (<< 9.22-1), xz-lzma
Breaks: lzip (<< 1.8~rc2), manpages-de (<< 4.1.0-1), manpages-fr (<< 4.1.0-1)
Replaces: lzip (<< 1.8~rc2), xz-lzma, manpages-de (<< 4.1.0-1), manpages-fr (<< 4.1.0-1)
Provides: lzma
Description: XZ-format compression utilities
 XZ is the successor to the Lempel-Ziv/Markov-chain Algorithm
 compression format, which provides memory-hungry but powerful
 compression (often better than bzip2) and fast, easy decompression.
 .
 This package provides the command line tools for working with XZ
 compression, including xz, unxz, xzcat, xzgrep, and so on. They can
 also handle the older LZMA format, and if invoked via appropriate
 symlinks will emulate the behavior of the commands in the lzma
 package.
 .
 The XZ format is similar to the older LZMA format but includes some
 improvements for general use:
 .
  * 'file' magic for detecting XZ files;
  * crc64 data integrity check;
  * limited random-access reading support;
  * improved support for multithreading (not used in xz-utils);
  * support for flushing the encoder.

Package: xzdec
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: foreign
Suggests: xz-utils
Breaks: xz-lzma (<< 4.999.9beta+20091004-1)
Replaces: xz-lzma (<< 4.999.9beta+20091004-1)
Description: XZ-format compression utilities - tiny decompressors
 XZ is the successor to the Lempel-Ziv/Markov-chain Algorithm
 compression format, which provides memory-hungry but powerful
 compression (often better than bzip2) and fast, easy decompression.
 .
 This package provides the xzdec and lzmadec utilities, which write
 the decompressed version of a compressed file to standard output. The
 binaries are very small, so they can be easily stored on small media
 with some compressed files, and they are linked statically against
 liblzma so they can be used on machines without a compatible version
 of liblzma installed. However, they have:
 .
   * no compression support;
   * no support for writing to a file other than standard output;
   * no translated messages;
   * been optimized for size rather than speed.
 .
 For a full-featured xzcat command without these limitations, use
 the xz-utils package instead.

Package: liblzma-dev
Section: libdevel
Multi-Arch: same
Architecture: any
Depends: liblzma5 (= ${binary:Version}), ${misc:Depends}
Suggests: liblzma-doc
Description: XZ-format compression library - development files
 XZ is the successor to the Lempel-Ziv/Markov-chain Algorithm
 compression format, which provides memory-hungry but powerful
 compression (often better than bzip2) and fast, easy decompression.
 .
 The native format of liblzma is XZ; it also supports raw (headerless)
 streams and the older LZMA format used by lzma. (For 7-Zip's related
 format, use the p7zip package instead.) This package provides the
 development library needed to build programs using liblzma.

Package: liblzma-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: liblzma-dev
Description: XZ-format compression library - API documentation
 This package contains a reference manual for the liblzma data
 compression library, in Doxygen-generated HTML files. The purpose
 of each struct, macro, and function in the public interface is
 explained.

=== main/alpine-baselayout/APKBUILD ===
# Contributor: Sören Tempel <soeren+alpine@soeren-tempel.net>
# Maintainer: Natanael Copa <ncopa@alpinelinux.org>
pkgname=alpine-baselayout
pkgver=3.6.8
pkgrel=1
pkgdesc="Alpine base dir structure and init scripts"
url="https://git.alpinelinux.org/cgit/aports/tree/main/alpine-baselayout"
arch="noarch"
license="GPL-2.0-only"
pkggroups="shadow"
replaces_priority=1000
options="!fhs !check keepdirs"
depends="$pkgname-data=$pkgver-r$pkgrel"
subpackages="$pkgname-data"
install="$pkgname.pre-install $pkgname.pre-upgrade $pkgname.post-upgrade
	$pkgname.post-install"
_nbver=6.4
source="crontab
	color_prompt.sh.disabled
	20locale.sh

	aliases.conf
	blacklist.conf
	i386.conf
	kms.conf

	group
	inittab
	passwd
	profile
	protocols-$_nbver::https://salsa.debian.org/md/netbase/-/raw/v$_nbver/etc/protocols
	services-$_nbver::https://salsa.debian.org/md/netbase/-/raw/v$_nbver/etc/services
	"
builddir="$srcdir/build"

prepare() {
	default_prepare
	mkdir -p "$builddir"
	mv "$srcdir"/protocols-$_nbver "$srcdir"/protocols
	mv "$srcdir"/services-$_nbver "$srcdir"/services
}

build() {
	# generate shadow
	awk -F: '{
		pw = ":!:"
		if ($1 == "root") { pw = "::" }
		print($1 pw ":0:::::")
	}' "$srcdir"/passwd > shadow
}

data() {
	replaces="alpine-baselayout"
	depends=

	amove etc/fstab
	amove etc/group
	amove etc/hostname
	amove etc/hosts
	amove etc/inittab
	amove etc/nsswitch.conf
	amove etc/modules
	amove etc/mtab
	amove etc/passwd
	amove etc/profile
	amove etc/protocols
	amove etc/services
	amove etc/shadow
	amove etc/shells
	amove etc/sysctl.conf
}

package() {
	mkdir -p "$pkgdir"
	cd "$pkgdir"
	install -m 0755 -d \
		dev \
		dev/pts \
		dev/shm \
		etc \
		etc/crontabs \
		etc/modprobe.d \
		etc/modules-load.d \
		etc/network \
		etc/network/if-down.d \
		etc/network/if-post-down.d \
		etc/network/if-pre-up.d \
		etc/network/if-up.d \
		etc/opt \
		etc/periodic \
		etc/periodic/15min \
		etc/periodic/daily \
		etc/periodic/hourly \
		etc/periodic/monthly \
		etc/periodic/weekly \
		etc/profile.d \
		etc/sysctl.d \
		home \
		lib \
		lib/firmware \
		lib/modules-load.d \
		lib/sysctl.d \
		media \
		media/cdrom \
		media/floppy \
		media/usb \
		mnt \
		proc \
		opt \
		run \
		run/lock \
		sbin \
		srv \
		sys \
		usr \
		usr/bin \
		usr/lib \
		usr/lib/modules-load.d \
		usr/lib/sysctl.d \
		usr/local \
		usr/local/bin \
		usr/local/lib \
		usr/local/share \
		usr/sbin \
		usr/share \
		usr/share/man \
		usr/share/misc \
		var \
		var/cache \
		var/cache/misc \
		var/lib \
		var/lib/misc \
		var/local \
		var/log \
		var/opt \
		var/spool \
		var/spool/cron \
		var/mail

	ln -s ../run var/run
	ln -s ../run/lock var/lock
	install -d -m 0555 var/empty
	install -d -m 0700 "$pkgdir"/root
	install -d -m 1777 "$pkgdir"/tmp "$pkgdir"/var/tmp

	install -m600 "$srcdir"/crontab "$pkgdir"/etc/crontabs/root
	install -m644 \
		"$srcdir"/color_prompt.sh.disabled \
		"$srcdir"/20locale.sh \
		"$pkgdir"/etc/profile.d/
	install -m644 \
		"$srcdir"/aliases.conf \
		"$srcdir"/blacklist.conf \
		"$srcdir"/i386.conf \
		"$srcdir"/kms.conf \
		"$pkgdir"/etc/modprobe.d/

	echo "localhost" > "$pkgdir"/etc/hostname
	cat > "$pkgdir"/etc/hosts <<-EOF
		127.0.0.1	localhost localhost.localdomain
		::1		localhost localhost.localdomain
	EOF
	cat > "$pkgdir"/etc/modules <<-EOF
		af_packet
		ipv6
	EOF
	cat > "$pkgdir"/etc/shells <<-EOF
		# valid login shells
		/bin/sh
		/bin/ash
	EOF
	cat > "$pkgdir"/etc/motd <<-EOF
		Welcome to Alpine!

		The Alpine Wiki contains a large amount of how-to guides and general
		information about administrating Alpine systems.
		See <https://wiki.alpinelinux.org/>.

		You can setup the system with the command: setup-alpine

		You may change this message by editing /etc/motd.

	EOF
	cat > "$pkgdir"/etc/sysctl.conf <<-EOF
		# content of this file will override /etc/sysctl.d/*
	EOF
	cat > "$pkgdir"/usr/lib/sysctl.d/00-alpine.conf <<-EOF
		# Prevents SYN DOS attacks. Applies to ipv6 as well, despite name.
		net.ipv4.tcp_syncookies = 1

		# Prevents ip spoofing.
		net.ipv4.conf.default.rp_filter = 1
		net.ipv4.conf.all.rp_filter = 1

		# Only groups within this id range can use ping.
		net.ipv4.ping_group_range=999 59999

		# Redirects can potentially be used to maliciously alter hosts
		# routing tables.
		net.ipv4.conf.all.accept_redirects = 0
		net.ipv4.conf.all.secure_redirects = 1
		net.ipv6.conf.all.accept_redirects = 0

		# The source routing feature includes some known vulnerabilities.
		net.ipv4.conf.all.accept_source_route = 0
		net.ipv6.conf.all.accept_source_route = 0

		# See RFC 1337
		net.ipv4.tcp_rfc1337 = 1

		## Enable IPv6 Privacy Extensions (see RFC4941 and RFC3041)
		net.ipv6.conf.default.use_tempaddr = 2
		net.ipv6.conf.all.use_tempaddr = 2

		# Restarts computer after 120 seconds after kernel panic
		kernel.panic = 120

		# Users should not be able to create soft or hard links to files
		# which they do not own. This mitigates several privilege
		# escalation vulnerabilities.
		fs.protected_hardlinks = 1
		fs.protected_symlinks = 1

		# Disable unprivileged use of the bpf(2) syscall.
		# Allowing unprivileged use of the bpf(2) syscall may allow a
		# malicious user to compromise the machine.
		kernel.unprivileged_bpf_disabled = 1
	EOF
	cat > "$pkgdir"/etc/fstab <<-EOF
		/dev/cdrom	/media/cdrom	iso9660	noauto,ro 0 0
		/dev/usbdisk	/media/usb	vfat	noauto,ro 0 0
	EOF
	cat > "$pkgdir"/etc/profile.d/README <<-EOF
		This directory should contain shell scripts configuring system-wide
		environment on users' shells.

		Files with the .sh extension found in this directory are evaluated by
		Bourne-compatible shells (like ash, bash or zsh) when started as a
		login shell.
	EOF
	cat > "$pkgdir"/etc/nsswitch.conf <<-EOF
		# musl itself does not support NSS, however some third-party DNS
		# implementations use the nsswitch.conf file to determine what
		# policy to follow.
		# Editing this file is not recommended.
		hosts: files dns
	EOF

	install -m644 \
		"$srcdir"/group \
		"$srcdir"/passwd \
		"$srcdir"/inittab \
		"$srcdir"/profile \
		"$srcdir"/protocols \
		"$srcdir"/services \
		"$pkgdir"/etc/

	install -m640 -g shadow "$builddir"/shadow \
		"$pkgdir"/etc/

	# symlinks
	ln -s ../../../etc/crontabs "$pkgdir"/var/spool/cron/crontabs
	ln -s ../proc/mounts "$pkgdir"/etc/mtab
	ln -s ../mail "$pkgdir"/var/spool/mail
}

sha512sums="
6e169c0975a1ad1ad871a863e8ee83f053de9ad0b58d94952efa4c28a8c221445d9e9732ad8b52832a50919c2f39aa965a929b3d5b3f9e62f169e2b2e0813d82  crontab
558071efdce2fe92afe4277006235b1a6368b070337c7567e5632a1a3fe531f87ca692eb36f3dda498d4d29d1f834fc8f7139f2985669ae3400b6d103d6f4c5e  color_prompt.sh.disabled
03361d912cf29c127608697ee14bfa5972f82a5c475e653378ca5f7670cbd8183efc7c8c339ff046ff6537944fe00c4a732bb6b552aecaecd1214ed3e11bdf90  20locale.sh
bfe947bdd69e7d93b32c8cb4e2cabe5717cb6c1e1f49a74015ac2cfb13e96d1f12c4be23ae93a1d61aaa3760d33a032fa9bd99f227fb21223a76b5f5908acc65  aliases.conf
0a1e1afa580751e80bf26057b65fadffe269c0552e7a1903de498f94973ba3da8453b51f25e649968ca5f4841266f5ccf951700fa28465a8614b83d07344de60  blacklist.conf
49109d434b577563849c43dd8141961ca798dada74d4d3f49003dac1911f522c43438b8241fa254e4faacdd90058f4d39a7d69b1f493f6d57422c1f706547c95  i386.conf
9dda8c9d1896baf1217aa05ae2936e909300a22a98da9f4c3ba29136852477bf4764321b6a1abb15e93ee58f4a6e77ddfc42cbb12cbbb53cf0f431ace444f72f  kms.conf
b5eb01165c714861e860f17c0156911ff882a9010306b7fc4cdb22251acf8b1c91a3fa1d44cc41cb3d9b50892e2f98f43da57b002c5c33200c1bf49c3d2d587d  group
37d7b8348e604b12c055d9d7e79afb568ededea7153ff552c9f383cffd537d9c78cfd9facd612d2a6753fc626ff608a6d22d62637585a33166aa28f59fabed22  inittab
f0d12f365839e7e262ec91e151119de7f2f253e9d0443157de4d52e183f421fbbb9eb0a83b9267a9ee850bebe41bff3c3cef553f9bda6e70d59a754a955be57d  passwd
4eb857ed59c2edb257636d2bf196989e514a273e9701e9f076c9ae8c1589b4898269180569960acf072c0981ec7ea54014fd230f014401d6bb92314285d1e6aa  profile
3a00083bcdf5a9e884c9d07877d52311e3d99e79cbee656e236ba06e08ba0dddb7ba76494fdc9dd1a826c48e197a790a69e6bb458e9df64832d6b5e904e9fd15  protocols-6.4
47b0f3ee73af2d259bd206a026204be0ea25531a895a0b035a904b38fe5407bc3dd2beab7f8fcb3d760587e6159702ebdb9cbc4f508942befdf7f10c10c87888  services-6.4
"
